package client;

import java.awt.Dimension;
import java.awt.GridLayout;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * Spouštěcí třída pro TCP klienta.
 */
public class TCPClientTest {

    public static void main(String[] args) {

        ConfigDialog conf = new ConfigDialog();
        do {
            int navrat = JOptionPane.showConfirmDialog(null, conf, "Nastavení spojení",
                    JOptionPane.OK_CANCEL_OPTION);
            if (navrat == JOptionPane.CANCEL_OPTION) {
                return;
            }
        } while (!conf.inputIsValid());

        TCPClient client = new TCPClient(conf.getHost(), conf.getPort());
        client.setVisible(true);
        client.runClient(conf.getFileName());
    }

    private static class ConfigDialog extends JPanel {

        JTextField host;
        JTextField port;
        JTextField file;

        public ConfigDialog() {
            super();
            host = new JTextField("127.0.0.1");
            port = new JTextField("12345");
            file = new JTextField("/etc/passwd");
            setLayout(new GridLayout(3, 2, 5, 5));
            add(new JLabel("Host:"));
            add(host);
            add(new JLabel("Port:"));
            add(port);
            add(new JLabel("File:"));
            add(file);
        }

        @Override
        public Dimension getMinimumSize() {
            return new Dimension(300, 90);
        }

        @Override
        public Dimension getPreferredSize() {
            return getMinimumSize();
        }

        public String getHost() {
            return host.getText();
        }

        public int getPort() throws NumberFormatException {
            return Integer.parseInt(port.getText());
        }

        public String getFileName() {
            return file.getText();
        }

        private boolean inputIsValid() {
            StringBuffer errorMessage = new StringBuffer();
            if (file.getText().equals("")) {
                errorMessage.append("Zadejte název souboru\n");
            }
            if (host.getText().equals("")) {
                errorMessage.append("Zadejte jméno hosta\n");
            }
            int port = 0;
            try {
                port = getPort();
                if (port <= 1024) {
                    errorMessage.append("Číslo portu musí být > 1024\n");
                }
            } catch (NumberFormatException e) {
                errorMessage.append("Port není platné číslo\n");
            }

            if (errorMessage.length() > 0) {
                JOptionPane.showMessageDialog(this, errorMessage.toString(), "Chyba", JOptionPane.ERROR_MESSAGE);
                return false;
            }
            return true;
        }
    }
}
